import React from "react";
import { TweenMax } from "gsap/TweenMax";

export default class HorizontalScroll extends React.Component {
  constructor(props) {
    super(props);
    this.content = React.createRef();

    this.resize = this.resize.bind(this);
    this.onWheel = this.onWheel.bind(this);
  }

  componentDidMount() {
    this.resize;
    this.onWheel;

    if (window !== undefined) {
      window.addEventListener("load", this.resize);
      window.addEventListener("resize", this.resize);
      window.addEventListener("scroll", this.onWheel);
    }
  }

  componentWillUnmount() {
    if (window !== undefined) {
      window.removeEventListener("load", this.resize);
      window.removeEventListener("resize", this.resize);
      window.removeEventListener("scroll", this.onWheel);
    }
  }

  resize() {
    document.body.style.height = this.content.current.offsetHeight + 'px';
  }

  onWheel() {
    const y = window.pageYOffset || document.documentElement.scrollTop;
    TweenMax.to(this.content.current, 1, {
      y: -y,
      ease: Power3.easeOut,
    });
  }

  render() {
    return (
      <div
        ref={this.content}
        style={{
          position: "fixed",
          top: "0",
          left: "0",
          width: "100%",
          height: "auto",
          willChange: "transform",
          transform: "translatez(0)"
        }}
      >
        {this.props.children}
      </div>
    );
  }
}
